import unittest

import torch
from torch import nn


class ELU(nn.Module):
    def __init__(self):
        super(ELU, self).__init__()
        self.elu = nn.ELU()

    def forward(self, x: torch.Tensor):
        out = self.elu(x)
        return out


class TestELU(unittest.TestCase):
    def test(self):
        activation = ELU()
        input = torch.randn(20, 100, 16)
        output = activation(input)
        self.assertEqual(list(output.shape), [20, 100, 16])
