import unittest

import torch
from torch import nn


class LeakyReLU(nn.Module):
    def __init__(self):
        super(LeakyReLU, self).__init__()
        self.leaky_relu = nn.LeakyReLU()

    def forward(self, x: torch.Tensor):
        out = self.leaky_relu(x)
        return out


class TestLeakyReLU(unittest.TestCase):
    def test(self):
        activation = LeakyReLU()
        input = torch.randn(20, 100, 16)
        output = activation(input)
        self.assertEqual(list(output.shape), [20, 100, 16])
