import unittest

import torch
from torch import nn


class GLU(nn.Module):
    def __init__(self):
        super(GLU, self).__init__()
        self.glu = nn.GLU()

    def forward(self, x: torch.Tensor):
        out1 = self.glu(x)
        out2 = self.glu(x)
        concatenated = torch.cat(
            [out1, out2],
            dim=2,
        )
        return concatenated


class TestGLU(unittest.TestCase):
    def test(self):
        activation = GLU()
        input = torch.randn(20, 100, 16)
        output = activation(input)
        self.assertEqual(list(output.shape), [20, 100, 16])
