import unittest

import torch
import torch.nn as nn


class Dropout(nn.Module):
    def __init__(self, dropout):
        super(Dropout, self).__init__()
        self.probability = dropout
        self.dropout = nn.Dropout(dropout)

    def forward(self, x):
        return self.dropout(x)


class TestDropout(unittest.TestCase):
    def test(self):
        dropout = Dropout(0.5)
        input = torch.randn(20, 100, 16)
        output = dropout(input)
        self.assertEqual(list(output.shape), [20, 100, 16])
