import torch.nn as nn


class ResidualConnectionWithMemory(nn.Module):
    def __init__(self, dim, dropout):
        super(ResidualConnectionWithMemory, self).__init__()
        self.layer_norm1 = nn.LayerNorm(dim)
        self.layer_norm2 = nn.LayerNorm(dim)
        self.dropout = nn.Dropout(dropout)

    def forward(self, x, z, inner_layer):
        return x + self.dropout(inner_layer(self.layer_norm1(x), self.layer_norm2(z)))
