import unittest

import torch
from torch import nn


class BatchNormalization(nn.Module):
    def __init__(self, embedding_dim: int):
        super(BatchNormalization, self).__init__()
        self.norm = nn.BatchNorm1d(embedding_dim)

    def forward(self, x):
        x = x.transpose(1, 2)
        out = self.norm(x)
        out = out.transpose(1, 2)
        return out


class TestBatchNormalization(unittest.TestCase):
    def test(self):
        norm = BatchNormalization(16)
        input = torch.randn(20, 100, 16)
        output = norm(input)
        self.assertEqual(list(output.shape), [20, 100, 16])
