import torch.nn as nn


class EncoderFirstElementRegression(nn.Module):
    def __init__(self, embedding_dim, input_dim, output_dim, patch_size):
        super(EncoderFirstElementRegression, self).__init__()
        self.embedding_dim = embedding_dim
        self.input_dim = input_dim
        self.output_dim = output_dim
        self.patch_size = patch_size

        self.linear = nn.Linear(embedding_dim, output_dim)

    def forward(self, x):
        first_output = x[:, 0, :].squeeze(1)
        output = self.linear(first_output)
        return output
