import json
import boto3


class S3Client:
    def __init__(self):
        self.client = boto3.client("s3")

    def upload_data(self, bucket, key, data):
        self.client.put_object(Bucket=bucket, Key=key, Body=data)

    def download_data(self, bucket, key):
        response = self.client.get_object(Bucket=bucket, Key=key)
        return response["Body"].read()

    def upload_json(self, bucket, key, dictionary: dict):
        json_str = json.dumps(dictionary)
        self.upload_data(bucket, key, json_str)

    def download_json(self, bucket, key) -> dict:
        data = self.download_data(bucket, key)
        dictionary = json.loads(data)
        return dictionary
